{

open messagebases
(c) 1999-2000 by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

13/12/99   + KillBase
26/01/00    small correctives
17/04/00   + BaseNameByExt
24/04/00   + CopyBase

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rOpen;
interface
Uses rAbs;
{}
const
{}
 MsgMask     : pChar = '*.msg';
 PktExt      : pChar = '.pkt';
 PktLetter   : Char  = 'P';
 SquLetter   : Char  = 'S';
 JamLetter   : Char  = 'J';
 MsgLetter   : Char  = 'F';
 msgLastRead : pChar = 'lastread';
{}
{
f,# - msg;
p   - pkt;
s,$ - squish;
j,! - jam;
}
{}
 function CreateBase(Name: String; aShareMode: Word): pAbsBase;
 function OpenOrCreateBase(Name: String; aShareMode: Word): pAbsBase;
 function KillBase(Name: String): Byte;
 function KillLastRead(Name: String): Byte;
 function BaseNameByExt(Name: String): String;
 function CopyBase(SourceBase, DestinationBase: String): Integer;
 function MoveBase(SourceBase, DestinationBase: String): Integer;
 function BaseLocked(BaseName: String; const stLockType: Word): Boolean;
{}
implementation
Uses Strings, rFidoMsg, rSquish, rJam, rObjects, rStrings, rCommon, Dos;
{}
function    BaseNameByExt(Name: String): String;
 var
  c: Char;
 begin
  BaseNameByExt:='';
  if Name='' then exit;
  if not (UpCase(Name[1]) in [PktLetter,MsgLetter,SquLetter,JamLetter,Lattice,Bucks,Excl]) then
   begin
    if (Point+UpStr(JustExtension(Name))=UpStr(JamHdrExt)) or
       (Point+UpStr(JustExtension(Name))=UpStr(JamTextExt)) or
       (Point+UpStr(JustExtension(Name))=UpStr(JamIndexExt)) then Name:=Excl+Name else
    if (Point+UpStr(JustExtension(Name))=UpStr(SqDataExt)) or
       (Point+UpStr(JustExtension(Name))=UpStr(SqIndexExt)) then Name:=Bucks+Name else
    if (JustExtension(Name)='') then Name:=Lattice+Name else
    if (Point+UpStr(JustExtension(Name))=UpStr(StrPas(PktExt))) then Name:=PktLetter+Name;
   end;
  if (Point+UpStr(JustExtension(Name))=UpStr(JamHdrExt)) or
     (Point+UpStr(JustExtension(Name))=UpStr(JamTextExt)) or
     (Point+UpStr(JustExtension(Name))=UpStr(JamIndexExt)) or
     (Point+UpStr(JustExtension(Name))=UpStr(SqDataExt)) or
     (Point+UpStr(JustExtension(Name))=UpStr(SqIndexExt)) then Name:=AddBackSlash(JustPathName(Name))+JustName(Name);
  c:=UpCase(Name[1]);
  if (c in [Lattice,MsgLetter]) then Name:=AddBackSlash(Name)+StrPas(MsgMask) else
  if (c in [PktLetter]) then Name:=AddBackSlash(JustPathName(Name))+JustFileName(Name) else
  if (c in [SquLetter,Bucks]) then Name:=AddBackSlash(JustPathName(Name))+JustFileName(Name) else
  if (c in [JamLetter,Excl]) then Name:=AddBackSlash(JustPathName(Name))+JustFileName(Name);
  BaseNameByExt:=Name;
 end;
{}
function    CreateBase(Name: String; aShareMode: Word): pAbsBase;
 var
  c: Char;
  Base: pAbsBase;
  sr: SearchRec;
  r: Byte;
 begin
  Base:=nil;
  CreateBase:=nil;
  if Name='' then exit;
  Name:=BaseNameByExt(Name);
  KillBase(Name);
  c:=UpCase(Name[1]);
  NewDelete(Name,1,1);
  if (c in [Lattice,MsgLetter]) then Base:=New(pMsgBase,Init) else
  if (c in [PktLetter]) then Base:=New(pPktBase,Init) else
  if (c in [SquLetter,Bucks]) then Base:=New(pSquishBase,Init) else
  if (c in [JamLetter,Excl]) then Base:=New(pJamBase,Init);
  r:=Base^.SaveBaseHdr(Name,aShareMode);
  if (Base^.BaseStatus<>bsOpened) or (r<>0) then DisposeObj(Base);
  CreateBase:=Base;
 end;
{}
function    OpenOrCreateBase(Name: String; aShareMode: Word): pAbsBase;
 var
  c: Char;
  Base: pAbsBase;
  r: Byte;
 begin
  Base:=nil;
  OpenOrCreateBase:=nil;
  if (Length(Name) in [0,1]) then exit;
  Name:=BaseNameByExt(Name);
  c:=UpCase(Name[1]);
  NewDelete(Name,1,1);
  r:=1;
  if (c in [MsgLetter,Lattice]) then Base:=New(pMsgBase,Init) else
  if (c in [PktLetter]) then Base:=New(pPktBase,Init) else
  if (c in [SquLetter,Bucks]) then Base:=New(pSquishBase,Init) else
  if (c in [JamLetter,Excl]) then Base:=New(pJamBase,Init);
  r:=Base^.LoadBaseHdr(Name,aShareMode);
  if (Base^.BaseStatus<>bsOpened) or (r<>0) then r:=Base^.SaveBaseHdr(Name,aShareMode);
  if r<>0 then
   begin
    DisposeObj(Base);
    OpenOrCreateBase:=nil;
   end
  else OpenOrCreateBase:=Base;
 end;
{}
function KillBase(Name: String): Byte;
 var
  c: Char;
  sr: SearchRec;
 begin
  KillBase:=1;
  if Name='' then exit;
  Name:=BaseNameByExt(Name);
  c:=UpCase(Name[1]);
  NewDelete(Name,1,1);
  if (c in [MsgLetter,Lattice]) then
   begin
    if DExist(JustPathName(Name)) then
     begin
      FindFirst(Name,AnyFile,sr);
      while DosError=0 do
       begin
        if (UpStr(JustExtension(sr.Name))='MSG') then KillFile(AddBackSlash(JustPathName(Name))+sr.Name);
        FindNext(sr);
       end;
{$IfDef VirtualPascal}
      FindClose(sr);
{$EndIf}
     end
   end
  else if (c in [PktLetter]) then KillFile(Name)
  else if (c in [SquLetter,Bucks]) then
   begin
    KillFile(Name+SqDataExt);
    KillFile(Name+SqIndexExt);
    KillFile(Name+SqLastReadExt);
   end
  else if (c in [JamLetter,Excl]) then
   begin
    KillFile(Name+JamHdrExt);
    KillFile(Name+JamTextExt);
    KillFile(Name+JamIndexExt);
    KillFile(Name+JamLastReadExt);
    KillFile(Name+JamLastReadExt1);
   end;
  KillBase:=0;
 end;
{}
function KillLastRead;
 var
  c: Char;
 begin
  KillLastRead:=1;
  if Name='' then exit;
  Name:=BaseNameByExt(Name);
  c:=UpCase(Name[1]);
  NewDelete(Name,1,1);
  if (c in [MsgLetter,Lattice]) then KillFile(AddBackSlash(Name)+StrPas(msgLastRead));
  if (c in [SquLetter,Bucks]) then KillFile(Name+SqLastReadExt);
  if (c in [JamLetter,Excl]) then KillFile(Name+JamLastReadExt);
  KillLastRead:=0;
 end;
{}
function CopyBase(SourceBase, DestinationBase: String): Integer;
 var
  c: Char;
  r: Integer;
  sr: SearchRec;
 begin
  CopyBase:=-1;
  r:=-1;
  if SourceBase='' then exit;
  SourceBase:=BaseNameByExt(SourceBase);
  c:=UpCase(SourceBase[1]);
  NewDelete(SourceBase,1,1);
  NewDelete(DestinationBase,1,1);
  if not mkTree(DestinationBase) then exit;
  if (c in [MsgLetter,Lattice]) then
   begin
    if DExist(RemoveBackSlash(JustPathName(SourceBase))) then
     begin
      FindFirst(SourceBase,AnyFile,sr);
      r:=0;
      while DosError=0 do
       begin
        if (UpStr(JustExtension(sr.Name))='MSG') then
        r:=CopyFile(AddBackSlash(JustPathName(SourceBase))+sr.Name,AddBackSlash(DestinationBase)+sr.Name,False)+r;
        FindNext(sr);
       end;
{$IfDef VirtualPascal}
      FindClose(sr);
{$EndIf}
      CopyFile(AddBackSlash(JustPathName(SourceBase))+StrPas(msgLastRead),
               AddBackSlash(DestinationBase)+StrPas(msgLastRead),False);
      CopyFile(AddBackSlash(JustPathName(SourceBase))+StrPas(rFidoMsg.msgLastRead),
               AddBackSlash(DestinationBase)+StrPas(rFidoMsg.msgLastRead),False);
     end;
   end
  else if (c in [PktLetter]) then
   begin
    SourceBase:=AddBackSlash(JustPathName(SourceBase))+JustName(SourceBase);
    r:=CopyFile(JustPathName(SourceBase),DestinationBase,false);
   end else
  if (c in [SquLetter,Bucks]) then
   begin
    SourceBase:=AddBackSlash(JustPathName(SourceBase))+JustName(SourceBase);
    r:=CopyFile(SourceBase+SqDataExt,DestinationBase+SqDataExt,false);
    r:=CopyFile(SourceBase+SqIndexExt,DestinationBase+SqIndexExt,false)+r;
    CopyFile(SourceBase+SqLastReadExt,DestinationBase+SqLastReadExt,false);
   end else
  if (c in [JamLetter,Excl]) then
   begin
    SourceBase:=AddBackSlash(JustPathName(SourceBase))+JustName(SourceBase);
    r:=CopyFile(SourceBase+JamHdrExt,DestinationBase+JamHdrExt,false);
    r:=CopyFile(SourceBase+JamTextExt,DestinationBase+JamTextExt,false)+r;
    r:=CopyFile(SourceBase+JamIndexExt,DestinationBase+JamIndexExt,false)+r;
    CopyFile(SourceBase+JamLastReadExt,DestinationBase+JamLastReadExt,false);
    CopyFile(SourceBase+JamLastReadExt1,DestinationBase+JamLastReadExt1,false);
   end;
  CopyBase:=r;
 end;
{}
function MoveBase(SourceBase, DestinationBase: String): Integer;
 var
  c: Char;
  r: Integer;
  sr: SearchRec;
 begin
  MoveBase:=-1;
  r:=-1;
  if SourceBase='' then exit;
  SourceBase:=BaseNameByExt(SourceBase);
  c:=UpCase(SourceBase[1]);
  NewDelete(SourceBase,1,1);
  NewDelete(DestinationBase,1,1);
  if not mkTree(DestinationBase) then exit;
  if (c in [MsgLetter,Lattice]) then
   begin
    if DExist(RemoveBackSlash(JustPathName(SourceBase))) then
     begin
      FindFirst(SourceBase,AnyFile,sr);
      r:=0;
      while DosError=0 do
       begin
        if (UpStr(JustExtension(sr.Name))='MSG') then
        r:=MoveFile(AddBackSlash(JustPathName(SourceBase))+sr.Name,AddBackSlash(DestinationBase)+sr.Name)+r;
        FindNext(sr);
       end;
{$IfDef VirtualPascal}
      FindClose(sr);
{$EndIf}
      MoveFile(AddBackSlash(JustPathName(SourceBase))+StrPas(msgLastRead),
               AddBackSlash(DestinationBase)+StrPas(msgLastRead));
      MoveFile(AddBackSlash(JustPathName(SourceBase))+StrPas(rFidoMsg.msgLastRead),
               AddBackSlash(DestinationBase)+StrPas(rFidoMsg.msgLastRead));
     end
    else r:=-1;
   end
  else if (c in [PktLetter]) then
   begin
    SourceBase:=AddBackSlash(JustPathName(SourceBase))+JustName(SourceBase);
    r:=MoveFile(SourceBase,DestinationBase);
   end else
  if (c in [SquLetter,Bucks]) then
   begin
    SourceBase:=AddBackSlash(JustPathName(SourceBase))+JustName(SourceBase);
    r:=MoveFile(SourceBase+SqDataExt,DestinationBase+SqDataExt);
    r:=MoveFile(SourceBase+SqIndexExt,DestinationBase+SqIndexExt)+r;
    MoveFile(SourceBase+SqLastReadExt,DestinationBase+SqLastReadExt);
   end else
  if (c in [JamLetter,Excl]) then
   begin
    SourceBase:=AddBackSlash(JustPathName(SourceBase))+JustName(SourceBase);
    r:=MoveFile(SourceBase+JamHdrExt,DestinationBase+JamHdrExt);
    r:=MoveFile(SourceBase+JamTextExt,DestinationBase+JamTextExt)+r;
    r:=MoveFile(SourceBase+JamIndexExt,DestinationBase+JamIndexExt)+r;
    MoveFile(SourceBase+JamLastReadExt,DestinationBase+JamLastReadExt);
    MoveFile(SourceBase+JamLastReadExt1,DestinationBase+JamLastReadExt1);
   end;
  MoveBase:=r;
 end;
{}
function BaseLocked(BaseName: String; const stLockType: Word): Boolean;
 var
  base: pAbsBase;
  c: Char;
 begin
  BaseLocked:=False;
  if (BaseName='') then exit;
  BaseName:=BaseNameByExt(BaseName);
  c:=UpCase(BaseName[1]);
  NewDelete(BaseName,1,1);
  if (c in [Lattice,MsgLetter]) then
   begin
    {msg-base always unlocked}
   end
  else if (c in [PktLetter]) then
   begin
    BaseLocked:=FileLocked(BaseName,stLockType);
   end
  else if (c in [SquLetter,Bucks]) then
   begin
    BaseLocked:=FileLocked(BaseName+SqDataExt,stLockType) or
                FileLocked(BaseName+SqIndexExt,stLockType) or
                FileLocked(BaseName+SqLastReadExt,stLockType);
   end
  else if (c in [JamLetter,Excl]) then
   begin
    BaseLocked:=FileLocked(BaseName+JamHdrExt,stLockType) or
                FileLocked(BaseName+JamTextExt,stLockType) or
                FileLocked(BaseName+JamIndexExt,stLockType) or
                FileLocked(BaseName+JamLastReadExt,stLockType) or
                FileLocked(BaseName+JamLastReadExt1,stLockType);
   end;
 end;
{}
end.
